//+------------------------------------------------------------------+
//|                                              Candle Strategy.mq5 |
//|                                  Copyright 2023, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Trade\Trade.mqh>
CTrade         m_trade;

input bool useManual=false;
input string _____________="Trade Paramenters";
input int MagicNumber=123;
input color BorderColor=clrBlue;
input string CandleTimeStart="10:15";
input string CandleTimeEnd="10:20";
input double entryPoint=200;
input double stopLosPoint=100;
input double TpRatio=1;
input bool DynamicLotSize  = true;
input double RiskPercent=1;
input double FixedLotSize    =   10;
input string ExitTradeTime="13:00";
input string __________="Trading Time";
input string startTime="10:15";
input string endTime="11:30";
input string ____________="Other";
input int maxTrades=5;
input int MinCandleValidatePoints=500;
input int MaxCandleValidatePoints=4500;
input double BreakEvenProfit=20;
input bool trendFilter=false;
input int period=50;
input ENUM_MA_METHOD InpMAMethod=MODE_EMA;  // Method

input string ______________="Trade Days";

input bool Monday=true;
input bool Tuesday=true;
input bool Wednesday=true;
input bool Thursday=true;
input bool Friday=true;



#include <Trade\PositionInfo.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\AccountInfo.mqh>
//---
CPositionInfo  m_position;                   // object of CPositionInfo class
CAccountInfo   m_account;                    // object of CAccountInfo class4
MqlTradeRequest requests;
MqlTradeResult results;
MqlTradeCheckResult checkResult;

bool tradesClosed = false; // initialize variable to false
int prevDay = -1; // initialize previous day to an invalid value

double buyslpoints=0.0;
double sellslpoints=0.0;


int AvgLHandle;
double orangeAvg[];

double EquityPercent   =    RiskPercent;

bool buyopen=false;
bool sellopen=false;


double buyOpenprice;
double buyslprice;

double sellOpenprice;
double sellslprice;


int countindex=0;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   EquityPercent   =    RiskPercent;
//---
   AvgLHandle= iMA(_Symbol,_Period,period,0,InpMAMethod,PRICE_CLOSE);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   countindex=0;
   deletex("upperline");
   deletex("lowerline");
   deletex("sl");

//---
   ObjectDelete(0,"upperline");
   ObjectDelete(0,"lowerline");
   ObjectDelete(0,"sl");
   ObjectDelete(0,"sl1");
   ObjectDelete(0,"box");
   ObjectDelete(0,"boxx");
   buyopen=false;
   sellopen=false;
   tradesClosed=false;
   countindex=0;
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {


   MqlDateTime time;
   datetime time_current=TimeCurrent();
   datetime time_local=TimeLocal();

   TimeToStruct(time_current,time);

   if(Monday && time.day_of_week == 1)
     {

      autotrade();
     }
   if(Tuesday && time.day_of_week == 2)
     {
      autotrade();
     }
   if(Wednesday && time.day_of_week == 3)
     {
      autotrade();
     }
   if(Thursday && time.day_of_week == 4)
     {
      autotrade();
     }
   if(Friday && time.day_of_week == 5)
     {
      autotrade();
     }

   if(useManual)
     {
      datetime candlexstartTime = StringToTime(CandleTimeStart);
      datetime candlexendTime = StringToTime(CandleTimeEnd);

      datetime sessionstartTime = StringToTime(startTime);
      datetime sessionendTime = StringToTime(endTime);
      for(int i=Bars(NULL,NULL,candlexstartTime,TimeCurrent()); i>0; i--)
        {

         if(iTime(NULL,NULL,i) == candlexendTime)
           {

            ObjectCreate(0,"upperline"+candlexendTime,OBJ_TREND,0,iTime(NULL,NULL,i+1),iHigh(NULL,NULL,i+1)+entryPoint*Point(),sessionendTime,iHigh(NULL,NULL,i+1)+entryPoint*Point());
            ObjectSetInteger(0,"upperline"+candlexendTime,OBJPROP_RAY,false);
            ObjectSetInteger(0,"upperline"+candlexendTime,OBJPROP_SELECTABLE,true);
            ObjectSetInteger(0,"upperline"+candlexendTime,OBJPROP_COLOR,clrGreen);

            ObjectCreate(0,"lowerline"+candlexendTime,OBJ_TREND,0,iTime(NULL,NULL,i+1),iLow(NULL,NULL,i+1)-entryPoint*Point(),sessionendTime,iLow(NULL,NULL,i+1)-entryPoint*Point());
            ObjectSetInteger(0,"lowerline"+candlexendTime,OBJPROP_RAY,false);
            ObjectSetInteger(0,"lowerline"+candlexendTime,OBJPROP_SELECTABLE,true);
            ObjectSetInteger(0,"lowerline"+candlexendTime,OBJPROP_COLOR,clrGreen);

            ObjectCreate(0,"sl"+candlexendTime,OBJ_TREND,0,iTime(NULL,NULL,i+1),iLow(NULL,NULL,i+1)-stopLosPoint *Point(),sessionendTime,iLow(NULL,NULL,i+1)-stopLosPoint*Point());
            ObjectSetInteger(0,"sl"+candlexendTime,OBJPROP_RAY,false);
            ObjectSetInteger(0,"sl"+candlexendTime,OBJPROP_SELECTABLE,true);

            ObjectCreate(0,"sl1"+candlexendTime,OBJ_TREND,0,iTime(NULL,NULL,i+1),iHigh(NULL,NULL,i+1)+stopLosPoint *Point(),sessionendTime,iHigh(NULL,NULL,i+1)+stopLosPoint*Point());
            ObjectSetInteger(0,"sl1"+candlexendTime,OBJPROP_RAY,false);
            ObjectSetInteger(0,"sl1"+candlexendTime,OBJPROP_SELECTABLE,true);

           }

        }
     }

  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deletex(string s="")
  {
   int objs =ObjectsTotal(0,0,-1);
   string name;
   for(int cnt=ObjectsTotal(0,0,-1)-1; cnt>=0; cnt--)
     {
      name=ObjectName(0,cnt,0,-1);
      if(StringSubstr(name,0,StringLen(s)) == s)
         ObjectDelete(0,name);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GenerateMagicNumber()
  {
   string symbolName = Symbol();
   int magicNumber = 0;

// Loop through each character in the symbol name and calculate a unique number
   for(int i = 0; i < StringLen(symbolName); i++)
     {
      magicNumber += StringGetCharacter(symbolName, i);
     }

   return magicNumber;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void autotrade()
  {

   CopyBuffer(AvgLHandle,0,0,iBars(NULL,NULL),orangeAvg);
   ArraySetAsSeries(orangeAvg, true);

   MqlDateTime time;

   int year = time.year;
   int month = time.mon;
   int day =time.day;

   datetime time_current=TimeCurrent();


   TimeToStruct(time_current,time);


   if(useManual==false)
     {


      modify(MagicNumber+2+GenerateMagicNumber());
      modify(MagicNumber+1+GenerateMagicNumber());


      //Close all trades after 12:00
      datetime existxstartTimex = StringToTime(ExitTradeTime);
      //+------------------------------------------------------------------+
      //|                                                                  |
      //+------------------------------------------------------------------+
      if(TimeCurrent()>=existxstartTimex)
        {
         CloseAll(MagicNumber+GenerateMagicNumber());
         ObjectDelete(0,"box");
         ObjectDelete(0,"boxx");
         buyopen=false;
         sellopen=false;
         tradesClosed=false;
         countindex=0;
        }

      if(fbo()>0)
        {
         tradesClosed=true;
         ObjectDelete(0,"box");
        }

      if(nsell(MagicNumber+2+GenerateMagicNumber())==0)
        {
         sellopen=false;
        }

      if(nbuy(MagicNumber+1+GenerateMagicNumber())==0)
        {
         buyopen=false;
        }


      //---
      datetime candlexstartTime = StringToTime(CandleTimeStart);
      datetime candlexendTime = StringToTime(CandleTimeEnd);

      if(TimeCurrent() > candlexstartTime && TimeCurrent() == candlexendTime)
        {
         ObjectCreate(0,"box",OBJ_RECTANGLE,0,iTime(NULL,NULL,1),iHigh(NULL,NULL,1),iTime(NULL,NULL,0),iLow(NULL,NULL,1));
         ObjectSetInteger(0,"box",OBJPROP_BORDER_COLOR,BorderColor);

        }

      datetime sessionstartTime = StringToTime(startTime);
      datetime sessionendTime = StringToTime(endTime);

      if(TimeCurrent() >= sessionstartTime && TimeCurrent() <= sessionendTime)
        {

         if(!tradesClosed && countindex<maxTrades)
           {


            if(!sellopen && nsell(MagicNumber+2+GenerateMagicNumber())==0  && ObjectFind(0,"box")==0 && ((trendFilter && ObjectGetDouble(0,"box",OBJPROP_PRICE,0)< orangeAvg[0]) || (trendFilter==false && true)))
              {

               if((((MathAbs(ObjectGetDouble(0,"box",OBJPROP_PRICE,0)-ObjectGetDouble(0,"box",OBJPROP_PRICE,1))/Point()))<=MaxCandleValidatePoints) && (((MathAbs(ObjectGetDouble(0,"box",OBJPROP_PRICE,0)-ObjectGetDouble(0,"box",OBJPROP_PRICE,1))/Point()))>=MinCandleValidatePoints))
                 {


                  if((ObjectGetDouble(0,"box",OBJPROP_PRICE,1)-entryPoint*Point())>SymbolInfoDouble(_Symbol,SYMBOL_BID))
                    {


                     double points= ((ObjectGetDouble(0,"box",OBJPROP_PRICE,0)+stopLosPoint*Point())-SymbolInfoDouble(_Symbol,SYMBOL_BID))/Point();

                     sellslpoints=points;

                     double lotSize = CalcLotSize(AccountInfoDouble(ACCOUNT_BALANCE), Symbol(), DynamicLotSize, RiskPercent, points, FixedLotSize);
                     VerifyLotSize(lotSize);

                     double     sSL=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits)+points*_Point;
                     double  tpv=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits)-(points*TpRatio)*_Point;

                     m_trade.SetExpertMagicNumber(MagicNumber+2+GenerateMagicNumber());
                     int ticket=    m_trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,lotSize,SymbolInfoDouble(_Symbol,SYMBOL_BID),sSL,tpv);
                     if(ticket>0)
                       {
                        buyopen=false;
                        sellopen=true;
                        countindex=countindex+1;
                       }


                     double high=ObjectGetDouble(0,"box",OBJPROP_PRICE,0);
                     double low=ObjectGetDouble(0,"box",OBJPROP_PRICE,1);
                     datetime time1=datetime(ObjectGetInteger(0,"box",OBJPROP_TIME,0));
                     datetime time2=sessionendTime;

                     if(ObjectCreate(0,"upperline"+time1,OBJ_TREND,0,time1,high+entryPoint*Point(),time2,high+entryPoint*Point()))
                       {
                        ObjectSetInteger(0,"upperline"+time1,OBJPROP_RAY,false);
                        ObjectSetInteger(0,"upperline"+time1,OBJPROP_SELECTABLE,true);
                        ObjectSetInteger(0,"upperline"+time1,OBJPROP_COLOR,clrGreen);

                        ObjectCreate(0,"lowerline"+time1,OBJ_TREND,0,time1,low-entryPoint*Point(),time2,low-entryPoint*Point());
                        ObjectSetInteger(0,"lowerline"+time1,OBJPROP_RAY,false);
                        ObjectSetInteger(0,"lowerline"+time1,OBJPROP_SELECTABLE,true);
                        ObjectSetInteger(0,"lowerline"+time1,OBJPROP_COLOR,clrGreen);

                        ObjectCreate(0,"sl"+time1,OBJ_TREND,0,time1,high+stopLosPoint *Point(),time2,high+stopLosPoint*Point());
                        ObjectSetInteger(0,"sl"+time1,OBJPROP_RAY,false);
                        ObjectSetInteger(0,"sl"+time1,OBJPROP_SELECTABLE,true);

                       }

                    }
                 }

              }
            //

            if(!buyopen && nbuy(MagicNumber+1+GenerateMagicNumber())==0  && ObjectFind(0,"box")==0  && ((trendFilter && ObjectGetDouble(0,"box",OBJPROP_PRICE,1)> orangeAvg[0]) || (trendFilter==false && true)))
              {


               if((((MathAbs(ObjectGetDouble(0,"box",OBJPROP_PRICE,0)-ObjectGetDouble(0,"box",OBJPROP_PRICE,1))/Point()))<=MaxCandleValidatePoints) && (((MathAbs(ObjectGetDouble(0,"box",OBJPROP_PRICE,0)-ObjectGetDouble(0,"box",OBJPROP_PRICE,1))/Point()))>=MinCandleValidatePoints))
                 {

                  if(SymbolInfoDouble(_Symbol,SYMBOL_ASK)>ObjectGetDouble(0,"box",OBJPROP_PRICE,0)+entryPoint*Point())
                    {

                     Comment("pl");

                     double points= (SymbolInfoDouble(_Symbol,SYMBOL_ASK)-(ObjectGetDouble(0,"box",OBJPROP_PRICE,1)-stopLosPoint*Point()))/Point();
                     buyslpoints=points;
                     double lotSize = CalcLotSize(AccountInfoDouble(ACCOUNT_BALANCE), Symbol(), DynamicLotSize, RiskPercent, points, FixedLotSize);
                     VerifyLotSize(lotSize);

                     double     sSL=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits)-points*_Point;
                     double  tpv=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits)+(points*TpRatio)*_Point;
                     m_trade.SetExpertMagicNumber(MagicNumber+1+GenerateMagicNumber());
                     int ticket=  m_trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,lotSize,SymbolInfoDouble(_Symbol,SYMBOL_ASK),sSL,tpv);
                     if(ticket>0)
                       {
                        buyopen=true;
                        sellopen=false;
                        countindex=countindex+1;

                       }
                     //

                     double high=ObjectGetDouble(0,"box",OBJPROP_PRICE,0);
                     double low=ObjectGetDouble(0,"box",OBJPROP_PRICE,1);
                     datetime time1=datetime(ObjectGetInteger(0,"box",OBJPROP_TIME,0));
                     datetime time2=sessionendTime;

                     if(ObjectCreate(0,"upperline"+time1,OBJ_TREND,0,time1,high+entryPoint*Point(),time2,high+entryPoint*Point()))
                       {


                        ObjectSetInteger(0,"upperline"+time1,OBJPROP_RAY,false);
                        ObjectSetInteger(0,"upperline"+time1,OBJPROP_SELECTABLE,true);
                        ObjectSetInteger(0,"upperline"+time1,OBJPROP_COLOR,clrGreen);

                        ObjectCreate(0,"lowerline"+time1,OBJ_TREND,0,time1,low-entryPoint*Point(),time2,low-entryPoint*Point());
                        ObjectSetInteger(0,"lowerline"+time1,OBJPROP_RAY,false);
                        ObjectSetInteger(0,"lowerline"+time1,OBJPROP_SELECTABLE,true);
                        ObjectSetInteger(0,"lowerline"+time1,OBJPROP_COLOR,clrGreen);

                        ObjectCreate(0,"sl"+time1,OBJ_TREND,0,time1,low-stopLosPoint *Point(),time2,low-stopLosPoint*Point());
                        ObjectSetInteger(0,"sl"+time1,OBJPROP_RAY,false);
                        ObjectSetInteger(0,"sl"+time1,OBJPROP_SELECTABLE,true);


                       }

                    }
                 }
              }


           }
        }
      //


     }

  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CalcLotSize(const double argAccountEquity,
                   const string argSymbol,
                   const bool   argDynamicLotSize,
                   const double argEquityPercent,
                   const double argStopLoss,
                   const double argFixedLotSize)
  {
   if(argDynamicLotSize && argStopLoss > 0)
     {
      double RiskAmount = argAccountEquity * (argEquityPercent / 100),
             TickValue  = SymbolInfoDouble(argSymbol,SYMBOL_TRADE_TICK_VALUE); // profit per pip

      if(_Point == 0.001 || _Point == 0.00001)
         TickValue *= 10;

      return ((RiskAmount / argStopLoss) / TickValue);
     }
//else
   return argFixedLotSize;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void VerifyLotSize(double &argLotSize)
  {
   if(argLotSize < SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MIN))
      argLotSize = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MIN);
   else
      if(argLotSize > SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MAX))
         argLotSize = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MAX);

   argLotSize = NormalizeDouble(argLotSize, SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_STEP) == 0.1 ? 1 : 2);
  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool SELL(double ll,int m,double sSL,double tpv)
  {

   sSL=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits)+sSL*_Point;
   tpv=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits)-(tpv*TpRatio)*_Point;


   ZeroMemory(requests);
   requests.symbol=_Symbol;
   requests.volume=ll;
   requests.action=TRADE_ACTION_DEAL;
   double price=0;

//Buy
   requests.type=ORDER_TYPE_SELL;
   price=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
   requests.sl=sSL;
   requests.tp=tpv;
   requests.comment="Recovery";
   requests.magic=m;

   requests.deviation=10;
   requests.price=price;

   if(OrderSend(requests,results))
     {
      return true;
     }
   else
     {
      return false;
     }
   return false;
  }
////////////////////////////////////////
bool BUY(double ll,int m,double sSL,double tpv)
  {

   sSL=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits)-sSL*_Point;
   tpv=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits)+(tpv*TpRatio)*_Point;


   ZeroMemory(requests);
   requests.symbol=_Symbol;
   requests.volume=ll;
   requests.action=TRADE_ACTION_DEAL;
   double price=0;

//Buy
   requests.type=ORDER_TYPE_BUY;
   price=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
   requests.sl=sSL;
   requests.tp=tpv;
   requests.comment="Recovery";
   requests.magic=m;

   requests.deviation=10;
   requests.price=price;
   if(OrderSend(requests,results))
     {
      return true;
     }
   else
     {
      return false;
     }
   return false;

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int nbuy(int m)
  {
   int buy=0;
   for(int i=0; i<PositionsTotal(); i++)
     {
      int sb=m_position.SelectByIndex(i);
      if(m_position.PositionType()==0 && m_position.Symbol()==_Symbol && m_position.Magic()==m)
         buy++;
     }
   return buy;

  }
//+------------------------------------------------------------------+
int nsell(int m)
  {
   int sel=0;
   for(int x=0; x<PositionsTotal(); x++)
     {
      int ss=m_position.SelectByIndex(x);
      if(m_position.PositionType()==1 && m_position.Symbol()==_Symbol && m_position.Magic()==m)
         sel++;

     }
   return sel;

  }

//all
int nall()
  {
   int sel=0;
   for(int x=0; x<PositionsTotal(); x++)
     {
      int ss=m_position.SelectByIndex(x);
      if((m_position.PositionType()==1 || m_position.PositionType()==0))
         sel++;

     }
   return sel;

  }
//+------------------------------------------------------------------+
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
//+------------------------------------------------------------------+
//| Disable trade in current bar(if one is already open)             |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
void CloseAll(int m)
  {
   for(int i=0; i<PositionsTotal(); i++)
     {
      int a=m_position.SelectByIndex(i);
        {
         if((m_position.PositionType()==POSITION_TYPE_BUY || m_position.PositionType()==POSITION_TYPE_SELL))
           {

            m_trade.PositionClose(m_position.Ticket());
           }
        }
     }
  }
//+------------------------------------------------------------------+
double fbo()
  {

   HistorySelect(0,TimeCurrent());
   int TotalDeals = HistoryDealsTotal();
   datetime LatestDeal = 0;
   ulong LatestTicket = 0;
   double LatestProfit=0.0;
   for(int i = 0; i < TotalDeals; i++)
     {

      ulong Ticket = HistoryDealGetTicket(i);
      if(TimeToString(TimeCurrent()-120)==TimeToString(HistoryDealGetInteger(Ticket,DEAL_TIME)-120) && HistoryDealGetInteger(Ticket,DEAL_ENTRY) == DEAL_ENTRY_OUT)
        {
         datetime DealTime = HistoryDealGetInteger(Ticket,DEAL_TIME);
         if(DealTime > LatestDeal)
           {
            LatestDeal = DealTime;
            LatestTicket = Ticket;
           }
        }
     }
   if(LatestTicket > 0)
     {
      LatestProfit = HistoryDealGetDouble(LatestTicket, DEAL_PROFIT);

     }
   return LatestProfit;
  }

//+------------------------------------------------------------------+
void modify(int mag)
  {


   if(buyOpenprice>0.0 && SymbolInfoDouble(_Symbol,SYMBOL_BID)<=buyOpenprice)
     {
      buyopen=false;
      buyOpenprice=0.0;
     }

   if(SymbolInfoDouble(_Symbol,SYMBOL_ASK)>=sellOpenprice&& sellOpenprice>0.0)
     {
      sellopen=false;
      sellOpenprice=0.0;
     }

   for(int i=0; i<PositionsTotal(); i++)
     {

      if(m_position.SelectByIndex(i))
        {
         if(m_position.PositionType()==0 && m_position.Symbol()==_Symbol && m_position.Magic()==mag)
           {

            double profitp=(SymbolInfoDouble(_Symbol,SYMBOL_BID)-m_position.PriceOpen())/Point();

            if(m_position.StopLoss()<m_position.PriceOpen() &&profitp>=buyslpoints)
              {
               if(iClose(NULL,NULL,0)>=m_position.PriceOpen()+buyslpoints*_Point)
                 {
                  bool mb=m_trade.PositionModify(m_position.Ticket(),  m_position.PriceOpen()+BreakEvenProfit*_Point, m_position.TakeProfit());
                  if(mb>0)
                    {
                     buyOpenprice=m_position.PriceOpen()+BreakEvenProfit*_Point;
                    }
                 }
              }



           }

         if(m_position.PositionType()==1 && m_position.Symbol()==_Symbol && m_position.Magic()==mag)
           {

            double profitp=(m_position.PriceOpen()-SymbolInfoDouble(_Symbol,SYMBOL_ASK))/Point();

            if(m_position.StopLoss()>m_position.PriceOpen() && profitp>=sellslpoints)
              {
               if(iClose(NULL,NULL,0)<=m_position.PriceOpen()-buyslpoints*_Point)
                 {
                  bool mb=m_trade.PositionModify(m_position.Ticket(),  m_position.PriceOpen()-BreakEvenProfit*_Point, m_position.TakeProfit());
                  if(mb>0)
                    {
                     sellOpenprice=m_position.PriceOpen()-BreakEvenProfit*_Point;
                    }
                 }
              }


           }

        }
     }


  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
